require 'class_extensions'

class OsmWay
  @@all_ways = {}
  attr_reader :json, :osmid, :tags

  def self.create_from_json(json)
    @@all_ways[json['id']] = OsmWay.new(json)
  end
  
  def initialize(ajson)
    @json = ajson
    @osmid = @json['id']
    @tags = @json['tags']
    @nodes = @json['nodes']
  end
  
  def self.find(id)
    result = @@all_ways[id]
    raise "Cesta s tímto osmid (#{id}) není v databázi" if result.nil?
    return result
  end
  def self.all; @@all_ways.values end
  
  def nodes; @nodes.collect{ |id| OsmNode.find(id) } end
  def node_osmids; @nodes; end
  def coordinates_array; nodes.collect {|node| node.coordinates } end
  def first; OsmNode.find(@nodes.first) end
  def last; OsmNode.find(@nodes.last) end
  
end